accounts/urls.py
from django.urls import path
from django.views.decorators.cache import cache_page

from .api import ProfileAutocompleteSearch
from .views import (
    MyProfileDetail,
    MyProfileDetailExport,
    MyProfileUpdate,
    UserCreate,
    UserDelete,
    UserDetail,
    UserListView,
    UserPassword,
    UserUpdate,
    change_password,
)

# from django.contrib.auth.paths import views
app_name = "accounts"

urlpatterns = [
    path("create", UserCreate.as_view(), name="user_create"),
    path("<int:pk>/update", UserUpdate.as_view(), name="user_update"),
    path("<int:pk>/password", UserPassword.as_view(), name="user_password"),
    path("<int:pk>/delete", UserDelete.as_view(), name="user_delete"),
    path("<int:pk>/detail", UserDetail.as_view(), name="user_detail"),
    path("myprofile/change_password", change_password, name="change_password"),
    path("myprofile/detail", MyProfileDetail.as_view(), name="myprofile_detail"),
    path(
        "myprofile/detail/export",
        MyProfileDetailExport.as_view(),
        name="myprofile_detail_export",
    ),
    path(
        "api/v1/profile/search",
        cache_page(60 * 15)(ProfileAutocompleteSearch.as_view()),
        name="profile_search_api",
    ),
    path("myprofile/update", MyProfileUpdate.as_view(), name="myprofile_update"),
    path("list", UserListView.as_view(), name="user_search"),
]

api/urls.py
# -*- coding: utf-8 -*-

# from django.contrib.auth.decorators import login_required
from django.urls import path

from .views import (  # GeoJSONTiledPlaceData,
    ActiveUserAutocomplete,
    AllUserAutocomplete,
    MetaPlaceAutocomplete,
    MunicipalityAutocomplete,
    PlaceAutocomplete,
    StudyAutocomplete,
    TaxaAutocomplete,
    TerritoryAutocomplete,
    metaplaces_as_geojson,
    places_as_geojson,
    places_in_metaplace_as_geojson,
)

# from sights.models import Municipality, Territory


# from djgeojson.views import GeoJSONLayerView


app_name = "general_api"

urlpatterns = [
    # path(
    #     "municipality.geojson",
    #     login_required(
    #         GeoJSONLayerView.as_view(
    #             model=Municipality,
    #             precision=3,
    #             simplify=0.5,
    #             properties=("name", "code"),
    #         )
    #     ),
    #     name="geodata_municipality",
    # ),
    # path(
    #     "territory.geojson",
    #     login_required(
    #         GeoJSONLayerView.as_view(
    #             model=Territory, precision=3, simplify=0.5, properties=("name", "code")
    #         )
    #     ),
    #     name="geodata_territory",
    # ),
    path("place.geojson", places_as_geojson, name="geodata_place"),
    path("metaplaces.geojson", metaplaces_as_geojson, name="geodata_metaplaces"),
    path(
        "metaplaces/places.geojson",
        places_in_metaplace_as_geojson,
        name="geodata_places_in_metaplaces",
    ),
    path(
        "metaplaces/<int:pk>/places.geojson",
        places_in_metaplace_as_geojson,
        name="geodata_place_in_metaplace",
    ),
    # path(
    #     "place/<int:z>/<int:x>/<int:y>",
    #     GeoJSONTiledPlaceData.as_view(),
    #     name="placetiled",
    # ),
    path(
        "active-user-autocomplete/",
        ActiveUserAutocomplete.as_view(),
        name="active_user_autocomplete",
    ),
    path(
        "all-user-autocomplete/",
        AllUserAutocomplete.as_view(),
        name="all_user_autocomplete",
    ),
    path("taxa-autocomplete/", TaxaAutocomplete.as_view(), name="taxa_autocomplete"),
    path(
        "municipality-autocomplete/",
        MunicipalityAutocomplete.as_view(),
        name="municipality_autocomplete",
    ),
    path(
        "territory-autocomplete/",
        TerritoryAutocomplete.as_view(),
        name="territory_autocomplete",
    ),
    path("place-autocomplete/", PlaceAutocomplete.as_view(), name="place_autocomplete"),
    path(
        "metaplace-autocomplete/",
        MetaPlaceAutocomplete.as_view(),
        name="metaplace_autocomplete",
    ),
    path(
        "v1/study/search",
        StudyAutocomplete.as_view(),
        name="study_autocomplete",
    ),
]

sights/urls.py
from django.urls import include, path

from sights.countdetail import urls as countdetail_urls
from sights.metaplace import urls as metaplace_urls
from sights.observation import urls as observation_urls
from sights.observation.views import SightingMyList, SightingUserList
from sights.place import urls as place_urls
from sights.place.views import PlaceMyList
from sights.session import urls as session_urls
from sights.session.views import SessionMyList

app_name = "sights"

urlpatterns = [
    path("user/place/list", PlaceMyList.as_view(), name="place_mylist"),
    path("user/session/list", SessionMyList.as_view(), name="session_mylist"),
    path("user/sighting/list", SightingMyList.as_view(), name="sighting_mylist"),
    path(
        "user/<int:pk>/sighting/list",
        SightingUserList.as_view(),
        name="user_sighting_list",
    ),
    path("", include(metaplace_urls)),
    path("", include(place_urls)),
    path("", include(session_urls)),
    path("", include(observation_urls)),
    path("", include(countdetail_urls)),
]

accounts/views.py
import logging

from django.conf import settings
from django.contrib.auth import get_user_model, update_session_auth_hash
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.mail import send_mail
from django.forms.models import model_to_dict
from django.shortcuts import render
from django.urls import reverse, reverse_lazy
from django.utils.translation import ugettext_lazy as _
from django.views.generic import DetailView
from django.views.generic.base import TemplateResponseMixin
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django_filters.views import FilterView
from django_tables2 import SingleTableView

from core.functions import generate_username

from .filters import ProfileFilter
from .forms import (
    PasswordUpdateForm,
    UserAdminUpdatePasswordForm,
    UserCreateAdminForm,
    UserCreateForm,
    UserUpdateAdminForm,
    UserUpdateForm,
)
from .mixins import ManageAccountAuthMixin, ManageMyAccountAuthMixin
from .models import Profile
from .tables import ProfileTable

logger = logging.getLogger(__name__)


class UserCreate(ManageAccountAuthMixin, CreateView):
    """
    User Creation View
    """

    model = Profile
    template_name = "leaflet_form.html"

    def get_form_class(self):
        user = self.request.user
        if user.edit_all_data or user.is_superuser:
            return UserCreateAdminForm
        else:
            return UserCreateForm

    def get_initial(self):
        initial = super(UserCreate, self).get_initial()
        initial = initial.copy()
        pwdgen = Profile.objects.make_random_password()
        initial["password_clear"] = pwdgen
        initial["password1"] = pwdgen
        initial["password2"] = pwdgen
        return initial

    def form_valid(self, form):
        form.instance.created_by = self.request.user.username
        form.instance.is_active = True
        form.instance.username = generate_username(
            form.instance.first_name, form.instance.last_name
        )
        # TODO : Email automatique à la création d'un nouveau compte avec identifiant et mot de passe
        form.instance.password1 = form.cleaned_data["password_clear"]
        form.instance.password2 = form.cleaned_data["password_clear"]
        emailinfo = form.save(commit=False)
        subject = _("Création de votre compte %s") % (emailinfo.username)
        system_sender = settings.DEFAULT_FROM_EMAIL
        real_sender = self.request.user.email
        txt_content = ("Identifiant: %s | mdp %s") % (
            emailinfo.username,
            form.cleaned_data["password_clear"],
        )
        html_content = (
            '<h1>Votre nouveau compte dbChiro.org</h1><p><b>Identifiant</b> : %s </p><p><b>Mot de passe</b> : %s </p><p><a href="http://%s">Connectez-vous ici</a></p><p>--<br/>%s<br/>%s</p>'
        ) % (
            emailinfo.username,
            form.cleaned_data["password_clear"],
            self.request.get_host(),
            self.request.user.get_full_name(),
            self.request.user.email,
        )
        receipter = [emailinfo.email, system_sender, real_sender]
        send_mail(
            subject,
            txt_content,
            system_sender,
            receipter,
            fail_silently=True,
            html_message=html_content,
        )
        form.save()
        return super(UserCreate, self).form_valid(form)

    def get_context_data(self, **kwargs):
        context = super(UserCreate, self).get_context_data(**kwargs)
        context["icon"] = "fi-torsos"
        context["title"] = "Création d'un compte"
        context[
            "js"
        ] = """
        """
        return context

        # def get_success_url(self):
        #     return reverse_lazy('user_search')


class UserUpdate(ManageAccountAuthMixin, UpdateView):
    """
    User Creation View
    """

    model = Profile
    template_name = "leaflet_form.html"

    def get_form_class(self):
        user = self.request.user
        if user.edit_all_data or user.is_superuser:
            return UserUpdateAdminForm
        else:
            return UserUpdateForm

    def get_form_kwargs(self):
        kwargs = super(UserUpdate, self).get_form_kwargs()
        # user = self.request.user
        return kwargs

    def form_valid(self, form):
        form.instance.updated_by = self.request.user.username
        form.instance.is_active = True
        return super(UserUpdate, self).form_valid(form)

    def get_context_data(self, **kwargs):
        context = super(UserUpdate, self).get_context_data(**kwargs)
        context["icon"] = "fi-torsos"
        context["title"] = "Modification d'un compte"
        return context


class UserPassword(ManageAccountAuthMixin, UpdateView):
    model = Profile
    form_class = UserAdminUpdatePasswordForm
    success_url = reverse_lazy("password_reset_complete")
    template_name = "normal_form.html"
    title = _("Enter new password")

    def get_form_kwargs(self):
        kwargs = super(UserPassword, self).get_form_kwargs()
        username = self.object.username
        logger.debug(username)
        return kwargs

    def get_success_url(self):
        return reverse("accounts:user_detail", kwargs={"pk": self.object.pk})

    def form_valid(self, form):
        form.instance.updated_by = self.request.user.username
        form.instance.is_active = True
        return super(UserPassword, self).form_valid(form)

    def get_context_data(self, **kwargs):
        context = super(UserPassword, self).get_context_data(**kwargs)
        context["title"] = _("Changement du mot de passe")
        context["icon"] = "fi-lock"
        context[
            "js"
        ] = """
        """
        return context


class MyProfileUpdate(ManageMyAccountAuthMixin, UpdateView):
    """
    User Creation View
    """

    model = Profile
    form_class = UserUpdateForm
    template_name = "leaflet_form.html"

    def form_valid(self, form):
        form.instance.updated_by = self.request.user.username
        return super(MyProfileUpdate, self).form_valid(form)

    def get_object(self):
        return get_user_model().objects.get(id=self.request.user.id)  # or request.POST

    def get_context_data(self, **kwargs):
        context = super(MyProfileUpdate, self).get_context_data(**kwargs)
        context["icon"] = "fi-torsos"
        context["title"] = _("Modification de mon compte")
        return context


class UserDelete(ManageAccountAuthMixin, DeleteView):
    model = Profile
    template_name = "confirm_delete.html"
    success_url = reverse_lazy("accounts:user_search")

    def get_context_data(self, **kwargs):
        context = super(UserDelete, self).get_context_data(**kwargs)
        context["icon"] = "fi-trash"
        context["title"] = "Suppression d'un compte"
        context["message_alert"] = _("Êtes-vous certain de vouloir supprimer l'utilisateur")
        return context


class UserDetail(LoginRequiredMixin, DetailView):
    model = get_user_model()
    template_name = "accounts/profile.html"


class MyProfileDetail(LoginRequiredMixin, DetailView):
    model = get_user_model()
    template_name = "accounts/my_profile.html"

    def get_object(self):
        logger.info(self.request.user.id)
        return get_user_model().objects.get(id=self.request.user.id)


class MyProfileDetailExport(LoginRequiredMixin, DetailView, TemplateResponseMixin):
    model = get_user_model()
    content_type = "text/plain; charset=utf-8"
    template_name = "accounts/personnal_data.txt"

    def get_object(self):
        logger.debug(self.request.user.id)
        profile = get_user_model().objects.get(id=self.request.user.id)
        dict = model_to_dict(profile)
        del dict["password"]
        return dict


@login_required()
def change_password(request):
    """
    Password update view
    :param request:
    :return:
    """
    form = PasswordUpdateForm(user=request.user)
    title = _("Modifier son mot de passe")
    icon = "fi-lock"
    js = ""
    if request.method == "POST":
        form = PasswordUpdateForm(user=request.user, data=request.POST)
        if form.is_valid():
            form.save()
            update_session_auth_hash(request, form.user)

    return render(
        request,
        "normal_form.html",
        {"form": form, "title": title, "icon": icon, "js": js},
    )


class UserListView(ManageAccountAuthMixin, FilterView, SingleTableView):
    table_class = ProfileTable
    model = Profile
    template_name = "table.html"

    filterset_class = ProfileFilter

    def get_queryset(self):
        """Returns accounts ordered by update timestamp"""
        return Profile.objects.all().order_by("-last_login")

    def get_context_data(self, **kwargs):
        context = super(UserListView, self).get_context_data(**kwargs)
        context["icon"] = "fi-torsos-all-female"
        context["title"] = _("Rechercher un observateur")
        context[
            "js"
        ] = """
        """
        return context

templates/accounts/change_password.html
{% extends 'base.html' %}

{% block content %}
<h1>Mise à jour du mot de passe</h1>
<form method="post">
  {% csrf_token %}
  {{ form }}
</form>
{% endblock %}

templates/accounts/my_profile.html
{% extends 'base.html' %} {% load i18n %} {% block title %}Mon profile ({{ object.username }}){%endblock %}
{% block content %}
<h1>
    <i class="fi-torsos-female-male"></i>
    {% trans "Mes données" %}
</h1>
<p class="text-muted">Compte créé le {{object.timestamp_create}}{% if object.timestamp_update %}, mis à jour le {{object.timestamp_update}}.{% endif %}
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <span class="pull-right">
                <a
                    class="text-info"
                    href="{% url 'accounts:myprofile_update' %}"
                    data-toggle="tooltip" data-placement="bottom"
                    title="{% trans 'Modifier mon profile' %}"
                    ><i class="fa fa-fw fa-user-edit"></i
                ></a>
                <a
                    class="text-warning"
                    href="{% url 'accounts:change_password' %}"
                    data-toggle="tooltip"
                    title="{% trans 'Modifier mon mot de passe' %}"
                    ><i class="fa fa-fw fa-lock"></i>
                </a>
                <a
                    class="text-info"
                    href="{% url 'accounts:myprofile_detail_export' %}"
                    data-toggle="tooltip"
                    title="{% trans 'Exporter mes données personnelles' %}"
                    ><i class="fa fa-fw fa-download"></i>
                </a>
            </span>
            <i class="fa fa-fw fa-id-card"></i> {% trans 'Identité' %}
        </h4>
    </div>
    <div class="panel-body">
       <h3>Informations principales</h1>
          <dl class="dl-horizontal">
  <dt>Nom d'utilisateur</dt>
  <dd>{{ object.username }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Nom complet</dt>
  <dd>{{ object.first_name }} {{ object.last_name }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Email</dt>
  <dd>{{ object.email }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Organisme</dt>
  <dd>{{ object.organism|default:'?' }}</dd>
</dl>
      <h3>Coordonnées</h3>
      <dl class="dl-horizontal">
  <dt>Téléphone fixe</dt>
  <dd>{{ object.home_phone|default:'?' }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Téléphone mobile</dt>
  <dd>{{ object.mobile_phone|default:'?' }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Adresse</dt>
  <dd>
  {% if object.addr_apt or object.addr_building %}{{ object.addr_appt }} {{ object.addr_building }}<br>{% endif %}
  {{ object.addr_street|default:'?' }}<br>
  {{ object.addr_city_code|default:'?'}} {{ object.addr_city|default:'?'}}<br>
  {{ object.addr_country|default:'?'}}
  </dd>
</dl>
    </div>
</div>
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <i class="fa fa-fw fa-id-card"></i> {% trans 'Mes observations' %}
        </h4>
    </div>
    <div class="panel-body">
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-primary btn-lg"
                href="{% url 'sights:place_mylist' %}"
                ><i class="fa fa-fw fa-map-marker-alt"></i>
                {% trans 'Mes localités' %}</a>
        </div>
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-primary btn-lg"
                href="{% url 'sights:session_mylist' %}"
                ><i class="fa fa-fw fa-calendar-alt"></i>
                {% trans 'Mes sessions' %}</a>
        </div>
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-primary btn-lg"
                href="{% url 'sights:sighting_mylist' %}"
                ><i class="fa fa-fw fa-eye"></i>
                {% trans 'Mes observations' %}</a>
        </div>
    </div>
</div>
{% if object.is_superuser or object.is_resp or object.edit_all_data or object.access_all_data %}
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <i class="fa fa-fw fa-unlock"></i> {% trans 'Droits sur la base' %}
        </h4>
    </div>
    <div class="panel-body">
        <b>Super-utilisateur</b> : {{ object.is_superuser|yesno:'Oui,Non,-' }}<br />
        <b>Responsable de territoire</b> : {% if object.is_resp %}Oui ( {% for territory in object.resp_territory.all %} {{ territory.name }}{% endfor %}){% else %}Non{% endif %}<br />
        <b>Accès à toutes les données</b>: {{ object.is_superuser|yesno:'Oui,Non,-'}}<br />
        <b>Edition de toutes les données</b>: {{ object.edit_all_data|yesno:'Oui,Non,-'}}<br />
    </div>
</div>
{% endif %}
{% endblock %}

templates/accounts/profile.html
{% extends 'base.html' %} {% load i18n %} {% block title %}{% trans "Utilisateur" %}  {{object.username}}{%endblock %}
{% block content %}
<h1>
    <i class="fi-torsos-female-male"></i>
    {% trans "Utilisateur" %}  {{object.username}}
</h1>
<p> <span class="text-muted">Compte créé le</span> {{object.timestamp_create}}
{% if object.timestamp_update %}
  <span class="text-muted">, mis à jour le </span>{{object.timestamp_update}}<span class="text-muted">.</span>
{% endif %}
<span class="text-muted"> Dernière connexion le </span>{{object.last_login|default:"Jamais"}}<span class="text-muted">.</span></p>
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <i class="fa fa-fw fa-id-card"></i> {% trans 'Identité' %}
        </h4>
    </div>
    <div class="panel-body">
    <h3>Informations principales</h1>
          <dl class="dl-horizontal">
  <dt>Nom d'utilisateur</dt>
  <dd><span class="label label-primary" style="font-size:1.5rem;">{{ object.username }}</strong></dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Nom complet</dt>
  <dd>{{ object.first_name }} {{ object.last_name }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Email</dt>
  <dd>{{ object.email }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Organisme</dt>
  <dd>{{ object.organism|default:'?' }}</dd>
</dl>
      <h3>Coordonnées</h3>
      <dl class="dl-horizontal">
  <dt>Téléphone fixe</dt>
  <dd>{{ object.home_phone|default:'?' }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Téléphone mobile</dt>
  <dd>{{ object.mobile_phone|default:'?' }}</dd>
</dl>
      <dl class="dl-horizontal">
  <dt>Adresse</dt>
  <dd>
  {% if object.addr_apt or object.addr_building %}{{ object.addr_appt }} {{ object.addr_building }}<br>{% endif %}
  {{ object.addr_street|default:'?' }}<br>
  {{ object.addr_city_code|default:'?'}} {{ object.addr_city|default:'?'}}<br>
  {{ object.addr_country|default:'?'}}
  </dd>
</dl>

    </div>
</div>
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <i class="fa fa-fw fa-id-card"></i> {% trans 'Gestion' %}
        </h4>
    </div>
    <div class="panel-body">
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-primary btn-lg"
                href="{% url 'accounts:user_update' pk=object.pk  %}"
                ><i class="fa fa-fw fa-edit"></i>
                {% trans 'Modifier' %}</a>
        </div>
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-warning btn-lg"
                href="{% url 'accounts:user_password' pk=object.pk %}"
                ><i class="fa fa-fw fa-lock"></i>
                {% trans 'Changer le mot de passe' %}</a>
        </div>
        <div class="col-xs-12 col-md-4">
            <a
                class="btn btn-block btn-danger btn-lg"
                href="{% url 'accounts:user_delete' pk=object.pk %}"
                ><i class="fa fa-fw fa-trash"></i>
                {% trans 'Supprimer' %}</a>
        </div>
    </div>
</div>
<div class="panel panel-group panel-default">
    <div class="panel-heading">
        <h4 class="panel-title">
            <i class="fa fa-fw fa-unlock"></i> {% trans 'Droits sur la base' %}
        </h4>
    </div>
    <div class="panel-body">
        <b>Super-utilisateur</b> : {{ object.is_superuser|yesno:'Oui,Non,-' }}<br />
        <b>Responsable de territoire</b> : {% if object.is_resp %}Oui ( {% for territory in object.resp_territory.all %} {{ territory.name }}{% endfor %}){% else %}Non{% endif %}<br />
        <b>Accès à toutes les données</b>: {{ object.is_superuser|yesno:'Oui,Non,-'}}<br />
        <b>Edition de toutes les données</b>: {{ object.edit_all_data|yesno:'Oui,Non,-'}}<br />
    </div>
</div>
{% endblock %}

templates/accounts/signup.html
{% extends 'base.html' %}

{% block content %}
  <h2>Sign up</h2>
  <form method="post">
    {% csrf_token %}
    {% for field in form %}
      <p>
        {{ field.label_tag }}<br>
        {{ field }}
        {% if field.help_text %}
          <small style="color: grey">{{ field.help_text }}</small>
        {% endif %}
        {% for error in field.errors %}
          <p style="color: red">{{ error }}</p>
        {% endfor %}
      </p>
    {% endfor %}
    <a class="button" type="submit">Sign up</a>
  </form>
{% endblock %}

templates/accounts/user_list.html
{% extends "base.html" %}
{% load render_table from django_tables2 %}
{% load crispy_forms_tags %}

{% block content %}
    <h1><i class="fi-torsos-all-female"></i> Rechercher un utilisateur</h1>
    <div class="panel panel-default">
        <div class="panel-body">
            <form action="" method="get">
                {{ filter.form.media }}
                {% crispy filter.form %}
            </form>
        </div>
    </div>
    <div class="panel panel-default">
    {% render_table table %}
    </div>
{% endblock %}